//// [anonymousClassExpression2.ts]
// Fixes #14860
// note: repros with `while (0);` too
// but it's less inscrutable and more obvious to put it *inside* the loop
while (0) {
    class A {
        methodA() {
            this; //note: a this reference of some kind is required to trigger the bug
        }
    }

    class B {
        methodB() {
            this.methodA; // error
            this.methodB; // ok
        }
    }
}


//// [anonymousClassExpression2.js]
var __names = (this && this.__names) || (function() {
    var name = Object.defineProperty ? (function(proto, name) {
        Object.defineProperty(proto[name], 'name', { 
            value: name, configurable: true
        });
    }) : (function(proto, name) {
        proto[name].name = name;
    });
    return function (proto, keys) {
        for (var i = keys.length - 1; i >= 0; i--) {
            name(proto, keys[i])
        }
    };
})();
// Fixes #14860
// note: repros with `while (0);` too
// but it's less inscrutable and more obvious to put it *inside* the loop
while (0) {
    var A = (function () {
        function A() {
        }
        A.prototype.methodA = function () {
            this; //note: a this reference of some kind is required to trigger the bug
        };
        __names(A.prototype, ["methodA"]);
        return A;
    }());
    var B = (function () {
        function B() {
        }
        B.prototype.methodB = function () {
            this.methodA; // error
            this.methodB; // ok
        };
        __names(B.prototype, ["methodB"]);
        return B;
    }());
}
